const Notification = {};
let Base = document.createElement('div');

/**
 * Main Config
 *
 * @type {{DefaultTime: number, Gutter: number, Padding: number, Class: [string], TextColor: string, BackgroundColor: string, ButtonColor: string}}
 */
Notification.config = {
    Class: [],
    DefaultTime: 3200,
}

/**
 * Create Base
 */
window.addEventListener('load', function () {

    let Body = document.querySelector('body');

    Notification.config.Class.push('ytpl-notification');
    Base.setAttribute('class', Notification.config.Class.join(' '))
    Body.appendChild(Base);

});

/**
 * Create Notification
 *
 * @param Data {{Text: string, AutoTime: boolean, Ok: {Text: string, Callback: function}, Cancel: {Text: string, Callback: function}}}
 * @constructor
 */
Notification.Add = function (Data) {

    let Element = document.createElement('div');
    let CONTENT = document.createElement('div');
    let BUTTONS = document.createElement('div');
    let Text = document.createElement('div');
    let OK = document.createElement('button');
    let CANCEL = document.createElement('button');

    Text.innerHTML = Data.Text;
    CONTENT.setAttribute('class', 'ytpl-content');

    if (Data.Cancel) {

        CANCEL.innerHTML = Data.Cancel.Text;
        CANCEL.setAttribute('class', 'ytpl-cancel');
        CANCEL.addEventListener('click', function (e) {

            if (Data.Cancel.Callback) {
                Data.Cancel.Callback(e, this);
            }
            Element.remove();

        });
        BUTTONS.appendChild(CANCEL);

    }

    if (Data.Ok) {

        OK.innerHTML = Data.Ok.Text;
        OK.setAttribute('class', 'ytpl-ok');
        OK.addEventListener('click', function (e) {

            if (Data.Ok.Callback) {
                Data.Ok.Callback(e, this);
            }
            Element.remove();

        });
        BUTTONS.appendChild(OK);

    }

    Element.setAttribute('class', 'ytpl-item');
    CONTENT.appendChild(Text);
    Element.appendChild(CONTENT);
    Element.appendChild(BUTTONS);
    Base.appendChild(Element);

    if (Data.AutoTime) {

        setTimeout(function () {
            Element.remove();
        }, Notification.config.DefaultTime);

    }

}