jQuery(document).ready(function ($) {

    /**
     * TODO ::: Checkbox
     */
    $(document).on('click', '.ytpl-field-checkbox', function () {

        let Field = $(this);
        let CheckBox = Field.find('.ytpl-checkbox');
        let Save = Field.find('.vpp--save');

        if (Save.val() === 'yes') {

            CheckBox.removeClass('active');
            Save.val('no');

        } else {

            CheckBox.addClass('active');
            Save.val('yes');

        }

    });

    /**
     * TODO ::: Radio
     */
    $(document).on('click', '.ytpl-field-radio .ytpl-option', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-radio');
        let Options = Field.find('.ytpl-option');
        let Save = Field.find('.vpp--save');

        Options.removeClass('active');
        Save.val(_this.attr('value'));
        _this.addClass('active');

    });

    /**
     * TODO ::: Thumbnail
     * Select
     */
    $(document).on('click', '.ytpl-field-thumbnail .ytpl-select', function () {

        let _this = $(this);
        let Field = _this.parent();
        let Media = Field.find('.ytpl-media');
        let Save = Field.find('.vpp--save');
        let Frame = wp.media({
            title: 'Select or Upload Media',
            button: {
                text: 'Select Image'
            },
            library: {
                type: ['image']
            },
            multiple: false  // Set to true to allow multiple files to be selected
        });

        Frame.open();
        Frame.on('select', function () {

            // Get media attachment details from the frame state
            let attachment = Frame.state().get('selection').first().toJSON();

            Media.html('<div class="ytpl-image" style="background:url(' + attachment.url + ')"></div>')
            Save.val(attachment.id);

        });

    });

    /**
     * Remove
     */
    $(document).on('click', '.ytpl-field-thumbnail .ytpl-image', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-thumbnail');
        let Save = Field.find('.vpp--save');

        _this.remove();
        Save.val('');

    });

    /**
     * TODO ::: Tags
     */
    $(document).on('keydown', '.ytpl-field-tags .enter-tag', function (e) {

        if (e.keyCode === 13) {

            let _this = $(this);
            let Fields = _this.parents('.ytpl-field-tags');
            let Options = Fields.find('.ytpl-options');
            let Save = Fields.find('.vpp--save');
            let Data = JSON.parse(Save.val());
            let s = _this.val();
            let l = true;

            $.each(Data, function (index, value) {

                if (s === value) l = false;

            });

            if (l) {

                Fields.find('.ytpl-empty').remove();
                Options.prepend(
                    '<div class="ytpl-item" data-text="' + s + '">\n' +
                    s +
                    '    <button>\n' +
                    '        <div class="ytpl-icon ytpl-icon-x">\n' +
                    '            <svg viewBox="0 0 24 24" style="pointer-events: none; display: block; width: 100%; height: 100%;">\n' +
                    '                <g>\n' +
                    '                    <path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"></path>\n' +
                    '                </g>\n' +
                    '            </svg>\n' +
                    '       </div>' +
                    '    </button>\n' +
                    '</div>'
                );

                _this.val('');
                Data.push(s);
                Save.val(JSON.stringify(Data));

                return false;

            }

            Notification.Add({
                Text: 'This tag is used',
                AutoTime: true,
                Ok: {
                    Text: 'OK'
                }
            });

        }

    });

    /**
     * Remove
     */
    $(document).on('click', '.ytpl-field-tags .ytpl-item button', function () {

        let _this = $(this);
        let Item = _this.parent();
        let Field = _this.parents('.ytpl-field-tags');
        let Save = Field.find('.vpp--save');
        let Data = JSON.parse(Save.val());
        let Text = Item.attr('data-text');
        let NewData = [];

        $.each(Data, function (index, value) {

            if (value === Text) return;
            NewData.push(value);

        });

        Item.remove();
        if (!NewData[0]) {

            Field.find('.ytpl-options').prepend(
                '<div class="ytpl-empty">Empty List</div>'
            );

        }

        Save.val(JSON.stringify(NewData));

    });

    /**
     * TODO ::: Quality
     * Add
     */
    $(document).on('click', '.ytpl-field-quality button', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-quality');
        let Item = _this.parents('.ytpl-item');
        let Items = Field.find('.ytpl-item');
        let FileName = Item.find('.ytpl-filename');
        let FileUrl = Item.find('.ytpl-fileurl');
        let Save = Field.find('.vpp--save');
        let Frame = wp.media({
            title: 'Select or Upload Media',
            button: {
                text: 'Select Image'
            },
            library: {
                type: ['video']
            },
            multiple: false  // Set to true to allow multiple files to be selected
        });

        Frame.open();
        Frame.on('select', function () {

            // Get media attachment details from the frame state
            let attachment = Frame.state().get('selection').first().toJSON();

            FileName.html('#(' + attachment.id + ') - ' + attachment.filename);
            FileUrl.html(attachment.url);
            Item.attr('data-id', attachment.id);

            let Data = {};
            Items.each(function () {

                let CELL = $(this).attr('data-cell');
                let ID = $(this).attr('data-id');

                if (ID) Data[CELL] = ID;

            });

            Save.val(JSON.stringify(Data));

        });

    });

    /**
     * Remove
     */
    $(document).on('click', '.ytpl-field-quality .ytpl-icon', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-quality');
        let Item = _this.parents('.ytpl-item');
        let FileName = Item.find('.ytpl-filename');
        let FileUrl = Item.find('.ytpl-fileurl');
        let CELL = Item.attr('data-cell');
        let Save = Field.find('.vpp--save');
        let Data = JSON.parse(Save.val());


        FileName.html('#(--) - ----');
        FileUrl.html('http://----');
        Item.removeAttr('data-id');

        delete Data[CELL];
        Save.val(JSON.stringify(Data));

    });

    /**
     * TODO ::: Subtitle
     * Add
     */
    $(document).on('click', '.ytpl-field-subtitle button', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-subtitle');
        let Element = Field.find('.ytpl_subtitle_items');
        let options = {
            "af": "Afrikaans",
            "am": "Amharic - አማርኛ",
            "an": "Aragonese - aragonés",
            "ar": "Arabic - العربية",
            "ast": "Asturian - asturianu",
            "az": "Azerbaijani - azərbaycan dili",
            "be": "Belarusian - беларуская",
            "bg": "Bulgarian - български",
            "bn": "Bengali - বাংলা",
            "br": "Breton - brezhoneg",
            "bs": "Bosnian - bosanski",
            "ca": "Catalan - català",
            "ckb": "Central Kurdish - کوردی (دەستنوسی عەرەبی)",
            "co": "Corsican",
            "cs": "Czech - čeština",
            "cy": "Welsh - Cymraeg",
            "da": "Danish - dansk",
            "de": "German - Deutsch",
            "de-AT": "German (Austria) - Deutsch (Österreich)",
            "de-CH": "German (Switzerland) - Deutsch (Schweiz)",
            "de-DE": "German (Germany) - Deutsch (Deutschland)",
            "de-LI": "German (Liechtenstein) - Deutsch (Liechtenstein)↵            ",
            "el": "Greek - Ελληνικά",
            "en": "English",
            "en-AU": "English (Australia)",
            "en-CA": "English (Canada)",
            "en-GB": "English (United Kingdom)",
            "en-IN": "English (India)",
            "en-NZ": "English (New Zealand)",
            "en-US": "English (United States)",
            "en-ZA": "English (South Africa)",
            "eo": "Esperanto - esperanto",
            "es": "Spanish - español",
            "es-419": "Spanish (Latin America) - español (Latinoamérica)↵            ",
            "es-AR": "Spanish (Argentina) - español (Argentina)",
            "es-ES": "Spanish (Spain) - español (España)",
            "es-MX": "Spanish (Mexico) - español (México)",
            "es-US": "Spanish (United States) - español (Estados Unidos)↵            ",
            "et": "Estonian - eesti",
            "eu": "Basque - euskara",
            "fa": "Persian - فارسی",
            "fi": "Finnish - suomi",
            "fil": "Filipino",
            "fo": "Faroese - føroyskt",
            "fr": "French - français",
            "fr-CA": "French (Canada) - français (Canada)",
            "fr-CH": "French (Switzerland) - français (Suisse)",
            "fr-FR": "French (France) - français (France)",
            "fy": "Western Frisian",
            "ga": "Irish - Gaeilge",
            "gd": "Scottish Gaelic",
            "gl": "Galician - galego",
            "gn": "Guarani",
            "gu": "Gujarati - ગુજરાતી",
            "ha": "Hausa",
            "haw": "Hawaiian - ʻŌlelo Hawaiʻi",
            "he": "Hebrew - עברית",
            "hi": "Hindi - हिन्दी",
            "hr": "Croatian - hrvatski",
            "hu": "Hungarian - magyar",
            "hy": "Armenian - հայերեն",
            "ia": "Interlingua",
            "id": "Indonesian - Indonesia",
            "is": "Icelandic - íslenska",
            "it": "Italian - italiano",
            "it-CH": "Italian (Switzerland) - italiano (Svizzera)",
            "it-IT": "Italian (Italy) - italiano (Italia)",
            "ja": "Japanese - 日本語",
            "ka": "Georgian - ქართული",
            "kk": "Kazakh - қазақ тілі",
            "km": "Khmer - ខ្មែរ",
            "kn": "Kannada - ಕನ್ನಡ",
            "ko": "Korean - 한국어",
            "ku": "Kurdish - Kurdî",
            "ky": "Kyrgyz - кыргызча",
            "la": "Latin",
            "ln": "Lingala - lingála",
            "lo": "Lao - ລາວ",
            "lt": "Lithuanian - lietuvių",
            "lv": "Latvian - latviešu",
            "mk": "Macedonian - македонски",
            "ml": "Malayalam - മലയാളം",
            "mn": "Mongolian - монгол",
            "mo": "Romanian (Moldova) - română (Moldova)",
            "mr": "Marathi - मराठी",
            "ms": "Malay - Bahasa Melayu",
            "mt": "Maltese - Malti",
            "nb": "Norwegian Bokmål - norsk bokmål",
            "ne": "Nepali - नेपाली",
            "nl": "Dutch - Nederlands",
            "nn": "Norwegian Nynorsk - nynorsk",
            "no": "Norwegian - norsk",
            "oc": "Occitan",
            "om": "Oromo - Oromoo",
            "or": "Oriya - ଓଡ଼ିଆ",
            "pa": "Punjabi - ਪੰਜਾਬੀ",
            "pl": "Polish - polski",
            "ps": "Pashto - پښتو",
            "pt": "Portuguese - português",
            "pt-BR": "Portuguese (Brazil) - português (Brasil)",
            "pt-PT": "Portuguese (Portugal) - português (Portugal)",
            "qu": "Quechua",
            "rm": "Romansh - rumantsch",
            "ro": "Romanian - română",
            "ru": "Russian - русский",
            "sd": "Sindhi",
            "sh": "Serbo-Croatian - Srpskohrvatski",
            "si": "Sinhala - සිංහල",
            "sk": "Slovak - slovenčina",
            "sl": "Slovenian - slovenščina",
            "sn": "Shona - chiShona",
            "so": "Somali - Soomaali",
            "sq": "Albanian - shqip",
            "sr": "Serbian - српски",
            "st": "Southern Sotho",
            "su": "Sundanese",
            "sv": "Swedish - svenska",
            "sw": "Swahili - Kiswahili",
            "ta": "Tamil - தமிழ்",
            "te": "Telugu - తెలుగు",
            "tg": "Tajik - тоҷикӣ",
            "th": "Thai - ไทย",
            "ti": "Tigrinya - ትግርኛ",
            "tk": "Turkmen",
            "to": "Tongan - lea fakatonga",
            "tr": "Turkish - Türkçe",
            "tt": "Tatar",
            "tw": "Twi",
            "ug": "Uyghur",
            "uk": "Ukrainian - українська",
            "ur": "Urdu - اردو",
            "uz": "Uzbek - o‘zbek",
            "vi": "Vietnamese - Tiếng Việt",
            "wa": "Walloon - wa",
            "xh": "Xhosa",
            "yi": "Yiddish",
            "yo": "Yoruba - Èdè Yorùbá",
            "zh": "Chinese - 中文",
            "zh-CN": "Chinese (Simplified) - 中文（简体）",
            "zh-HK": "Chinese (Hong Kong) - 中文（香港）",
            "zh-TW": "Chinese (Traditional) - 中文（繁體）",
            "zu": "Zulu - isiZulu"
        };
        let SelectOptions = '';

        $.each(options, function (index, value) {
            SelectOptions += '<option value="' + index + '">' + value + '</option>';
        });

        Element.append(
            '<div class="ytpl-item">\n' +
            '    <div class="ytpl-field ytpl-field-select">\n' +
            '        <label>Language</label>\n' +
            '        <select>' + SelectOptions + '</select>\n' +
            '    </div>\n' +
            '    <div class="ytpl-subtitle-selector">Select File</div>\n' +
            '    <div class="ytpl-subtitle-delete">' +
            '        <svg viewBox="0 0 24 24" style="pointer-events: none; display: block; width: 100%; height: 100%;">\n' +
            '            <g>\n' +
            '                <path d="M6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zM19 4h-3.5l-1-1h-5l-1 1H5v2h14V4z"></path>\n' +
            '            </g>\n' +
            '        </svg>' +
            '    </div>\n' +
            '    <input type="hidden" class="vpp--save" name="subtitle_" value=\'{"lang":"","file":""}\'>' +
            '</div>'
        );

    });

    /**
     * Change Language
     */
    $(document).on('change', '.ytpl-field-subtitle select', function () {

        let _this = $(this);
        let Item = _this.parents('.ytpl-item');
        let Save = Item.find('.vpp--save');
        let Data = JSON.parse(Save.val());

        Data.lang = $(this).val();
        Save.attr('name', 'subtitle_' + $(this).val());
        Save.val(JSON.stringify(Data));

    });

    /**
     * Select File
     */
    $(document).on('click', '.ytpl-field-subtitle .ytpl-subtitle-selector', function () {

        let _this = $(this);
        let Item = _this.parents('.ytpl-item');
        let Save = Item.find('.vpp--save');
        let Data = JSON.parse(Save.val());
        let Frame = wp.media({
            title: 'Select or Upload Subtitle',
            button: {
                text: 'Select Subtitle'
            },
            multiple: false  // Set to true to allow multiple files to be selected
        });

        Frame.open();
        Frame.on('select', function () {

            // Get media attachment details from the frame state
            let attachment = Frame.state().get('selection').first().toJSON();

            Data.file = attachment.id;
            _this.html(attachment.filename);
            Save.val(JSON.stringify(Data));

        });

    });

    /**
     * Delete
     */
    $(document).on('click', '.ytpl-field-subtitle .ytpl-subtitle-delete', function () {
        $(this).parents('.ytpl-item').remove();
    });

    /**
     * TODO ::: Video Selector
     */
    $(document).on('click', '.ytpl-field-video .ytpl-select', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-video');
        let Video = Field.find('video');
        let Link = Field.find('.ytpl-link');
        let Filename = Field.find('.ytpl-filename');
        let Save = Field.find('.vpp--save');
        let Frame = wp.media({
            title: 'Select or Upload Media',
            button: {
                text: 'Select Video'
            },
            library: {
                type: ['video']
            },
            multiple: false  // Set to true to allow multiple files to be selected
        });

        // Functions
        const SetVideo = function (video, url) {

            video[0].src = url;
            video.load();

        }

        Frame.open();
        Frame.on('select', function () {

            // Get media attachment details from the frame state
            let attachment = Frame.state().get('selection').first().toJSON();

            SetVideo(Video, attachment.url);
            Link.html(attachment.url);
            Link[0].href = attachment.url;
            Filename.html(attachment.filename);
            Save.val(attachment.id);

            let WorkSpace = _this.parents('.ytpl-popup-box').find('#ytpl_step_line_c2');
            if (!WorkSpace[0]) {
                WorkSpace = _this.parents('.ytpl-accordion').find('#element');
            }
            YTPL_STUDIO_EDITOR_RESET_VIDEO(WorkSpace.find('.ytpl-field-editor').attr('data-id'), attachment.url)

            WorkSpace = _this.parents('.ytpl-popup-box').find('#ytpl_step_line_c3');
            if (!WorkSpace[0]) {
                WorkSpace = _this.parents('.ytpl-accordion').find('#visibility');
            }

            Video = WorkSpace.find('video');
            Link = WorkSpace.find('.ytpl-link');
            Filename = WorkSpace.find('.ytpl-filename');

            SetVideo(Video, attachment.url);
            Link.html(attachment.url);
            Link[0].href = attachment.url;
            Filename.html(attachment.filename);
            Save.val(attachment.id);

        });

    });

    /**
     * TODO ::: Element
     * Add link
     */
    $(document).on('click', '.ytpl-field-edit .ytpl-option[data-name="link"]', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-edit');
        let ElementBox = Field.find('.ytpl-element');
        let Rand = Math.floor((Math.random() * 99999) + 1);
        let Element =
            '<div class="ytpl-element-option">\n' +
            '    <div class="ytpl-title">Link</div>\n' +
            '    <div class="ytpl-options">\n' +
            '        <div class="ytpl-time">\n' +
            '            <div>\n' +
            '                <div class="ytpl-field ytpl-field-text">\n' +
            '                    <label>Start Time</label>\n' +
            '                    <input type="text" name="start-time">\n' +
            '                </div>\n' +
            '            </div>\n' +
            '            <div>\n' +
            '                <button>Set Current Time</button>\n' +
            '            </div>\n' +
            '        </div>\n' +
            '        <div class="ytpl-time">\n' +
            '            <div>\n' +
            '                <div class="ytpl-field ytpl-field-text">\n' +
            '                    <label>End Time</label>\n' +
            '                    <input type="text" name="end-time">\n' +
            '                </div>\n' +
            '            </div>\n' +
            '            <div>\n' +
            '                <button>Set Current Time</button>\n' +
            '            </div>\n' +
            '        </div>\n' +
            '        <div class="ytpl-field ytpl-field-text">\n' +
            '            <label>Title</label>\n' +
            '            <input type="text" name="title">\n' +
            '        </div>\n' +
            '        <div class="ytpl-field ytpl-field-text">\n' +
            '            <label>Link</label>\n' +
            '            <input type="text" name="link">\n' +
            '        </div>\n' +
            '    </div>\n' +
            '    <input type="hidden" class="vpp--save" name="element_link_' + Rand + '">\n' +
            '</div>';

        ElementBox.append(Element);

    });

    /**
     * Set Current Time
     */
    $(document).on('click', '.ytpl-field-edit .ytpl-time button', function () {

        let _this = $(this);
        let Field = _this.parents('.ytpl-field-edit');
        let Item = _this.parents('.ytpl-time');
        let Input = Item.find('input');
        let Video = Field.find('video');

        Input.val(Video[0].currentTime);
        Input.trigger('keyup');

    });

    /**
     * Change Video Editor Input
     */
    $(document).on('keyup', '.ytpl-field-edit input[type=text]', function () {

        let _this = $(this);
        let Option = _this.parents('.ytpl-element-option')
        let Save = Option.find('.vpp--save');
        let Input = Option.find('input[type=text]');
        let Data = {};

        Input.each(function () {
            Data[$(this).attr('name')] = $(this).val();
        });

        Save.val(JSON.stringify(Data));

    });

    /**
     * TODO ::: Step Line
     */
    $(document).on('click', '.ytpl-step-line-content > div', function () {

        let items = $('.ytpl-step-line-content > div');
        let _index = $(this).index();
        let content = null;

        items.each(function (index) {

            if (index <= _index) {

                $(this).addClass('active');
                content = $(this);

            } else $(this).removeClass('active');

            $('#' + $(this).attr('data-id')).hide();

        });

        $('#' + content.attr('data-id')).show();

    });

    /**
     * Nav Box
     */
    $(document).on('click', '.ytpl-nav-box .ytpl-nav-item', function () {

        let base = $(this).parents('.ytpl-nav-box');
        let nav_items = base.find('.ytpl-nav-item');
        let content_item = base.find('.ytpl-nav-content-item');

        nav_items.removeClass('active');
        $(this).addClass('active');

        content_item.hide();
        base.find('#' + $(this).attr('data-id')).show();

    });

});