jQuery(document).ready(function ($) {

    /**
     * Global Variable
     */

    let page = 'video';
    let current_page = 1;
    let per_page = 10;
    let PageConfig = {};

    /**
     * TODO ::: Create Loading
     *
     * @param Remove
     * @constructor
     */
    $.fn.YTPL_Loading = function (Remove) {

        let _this = $(this);

        _this[0].scrollTop = 0;

        if (Remove) {
            _this.find('ytpl-loading');
        } else {

            let Loading = $('<div class="ytpl-loading"><div></div></div>');
            _this.append(Loading);

        }

    }

    /**
     * Load Page
     */
    ContentRender();
    $('.ytpl-loading').remove();

    /**
     *  Shortcuts
     */
    $(document).on('keydown', function (e) {

        /**
         * Close popup
         */
        if (e.keyCode === 27 || e.keyCode === 115) {

            $('.ytpl-popup-box .ytpl-icon-x').trigger('click');
            $('.ytpl-popup-box > div:nth-child(3) > div:nth-child(2)').trigger('click');
            return false;

        }

        /**
         * Open create popup
         */
        if (e.ctrlKey && e.keyCode === 81) {

            $('#ytpl_show_popup_create').trigger('click');
            return false;

        }

        /**
         * Open Setting popup
         */
        if (e.ctrlKey && e.keyCode === 83) {

            $('#ytpl_show_popup_setting').trigger('click');
            return false;

        }

        /**
         * Open Info popup
         */
        if (e.ctrlKey && e.keyCode === 73) {

            $('#ytpl_show_popup_about_me').trigger('click');
            return false;

        }

        /**
         * Change page to video
         */
        if (e.ctrlKey && e.keyCode === 49) {

            page = 'video';
            $('.ytpl-left-nav .ytpl-nav-item[data-page=video]').trigger('click');
            ContentRender();

            return false;

        }

        /**
         * Change page to playlist
         */
        if (e.ctrlKey && e.keyCode === 50) {

            page = 'playlist';
            $('.ytpl-left-nav .ytpl-nav-item[data-page=playlist]').trigger('click');
            ContentRender();

            return false;

        }

        /**
         * Change page to subtitle
         */
        if (e.ctrlKey && e.keyCode === 51) {

            page = 'subtitle';
            $('.ytpl-left-nav .ytpl-nav-item[data-page=subtitle]').trigger('click');
            ContentRender();

            return false;

        }

        /**
         * Search
         */
        if (e.ctrlKey && e.keyCode === 70) {

            $('.ytpl-header .ytpl-search input').focus();
            return false;

        }

    });

    /**
     * TODO ::: Check box table
     * Selected
     */
    $(document).on('click', '.ytpl-table-body .ytpl-field-checkbox', function () {

        let Table = $(this).parents('.ytpl-table');
        let HeaderCheck = Table.find('.ytpl-table-header .ytpl-field-checkbox');
        let Child = Table.find('.ytpl-table-body .ytpl-field-checkbox .vpp--save');
        let Data = [];

        Child.each(function () {

            let _this = $(this);
            if (_this.val() === 'yes') Data.push(_this.attr('name'));

        });

        if (Data.length === Child.length) {

            HeaderCheck.find('.ytpl-checkbox').addClass('active');
            HeaderCheck.find('.vpp--save').val('yes');

        } else {

            HeaderCheck.find('.ytpl-checkbox').removeClass('active');
            HeaderCheck.find('.vpp--save').val('no');

        }

        TableItemSelector(Table, Data, Child.length, Table.attr('data-action'));

    });

    /**
     * Select all
     */
    $(document).on('click', '.ytpl-table-header .ytpl-field-checkbox', function () {

        let All = $(this);
        let Table = $(this).parents('.ytpl-table');
        let Child = Table.find('.ytpl-table-body .ytpl-field-checkbox');
        let Data = [];

        Child.each(function () {

            let _this = $(this);
            if (All.find('.vpp--save').val() === 'yes') {

                _this.find('.ytpl-checkbox').addClass('active');
                _this.find('.vpp--save').val('yes');
                Data.push(_this.find('.vpp--save').attr('name'));

            } else {

                _this.find('.ytpl-checkbox').removeClass('active');
                _this.find('.vpp--save').val('no');

            }

        });

        TableItemSelector(Table, Data, Child.length, Table.attr('data-action'));

    });

    /**
     * TODO ::: Change Page
     */
    $(document).on('click', '.ytpl-left-nav > div:nth-child(2) .ytpl-nav-item', function () {

        let items = $('.ytpl-left-nav > div:nth-child(2) .ytpl-nav-item');

        items.removeClass('active');
        $(this).addClass('active');

        current_page = 1;
        per_page = 10;
        page = $(this).attr('data-page');
        ContentRender();

    });

    /**
     * Change page data in page
     */
    $(document).on('click', '.ytpl-table-pagination .ytpl-icon-button', function () {

        let dataPage = $(this).attr('data-page');
        if (dataPage) {

            current_page = dataPage;
            ContentRender();

        }

    });

    /**
     * Change per_page
     */
    $(document).on('change', '.ytpl-per-page select', function () {

        current_page = 1;
        per_page = $(this).val();
        ContentRender();

    });

    /**
     * Accordion
     */
    $(document).on('click', '.ytpl-accordion .ytpl-tabs .ytpl-tab-button', function () {

        let _this = $(this);
        let Accordion = _this.parents('.ytpl-accordion');
        let Tabs = _this.parent().find('.ytpl-tab-button');

        Tabs.removeClass('active');
        _this.addClass('active');
        Accordion.find('.ytpl-content > div').hide();
        Accordion.find('#' + _this.attr('data-id')).show();

    });

    /**
     * Update Video
     */
    $(document).on('click', '#ytpl_save_update_video', function () {

        let Fields = $('.vpp--save');
        let Subtitle = {};
        let Config = {};

        Fields.each(function () {

            let Name = $(this).attr('name');

            // Subtitle
            if (Name.indexOf('subtitle_') !== -1) {

                Subtitle[Name] = $(this).val() !== '' ? JSON.parse($(this).val()) : {};
                return;

            }

            // Element
            if (Name === 'elements') {

                Config[Name] = $(this).val() !== '' ? JSON.parse($(this).val()) : {};
                return;

            }

            // Quality or Tags
            if (Name === 'quality' || Name === 'tags') {

                Config[Name] = $(this).val() !== '' ? JSON.parse($(this).val()) : {};
                return;

            }

            // Any
            Config[Name] = $(this).val();

        });

        Config['id'] = PageConfig.id;
        Config['subtitle'] = Subtitle;

        let ajaxData = {
            nonce: vpp_ajax_config.Nonce,
            action: 'ytpl_update_video',
            config: JSON.stringify(Config)
        }

        $.ajax({
            type: "POST",
            url: vpp_ajax_config.AjaxUrl,
            data: ajaxData,
            success: function (resp) {

                Notification.Add({
                    Text: VPP_TRANSLATE.notification_video_update_title,
                    AutoTime: true,
                    Ok: {Text: VPP_TRANSLATE.notification_ok}
                });

            },
            timeout: 10000
        });

    });

    /**
     * Subtitle Edit Page
     */
    $(document).on('click', '#ytpl_show_edit_subtitle', function () {

        page = 'subtitle_edit';
        ContentRender();

    });

    /**
     * Subtitle Edit for list
     */
    $(document).on('click', '.ytpl-subtitle-list-edit-button', function () {

        page = 'subtitle_edit';
        PageConfig = {
            id: $(this).attr('data-id')
        }
        ContentRender();

    });

    /**
     * Subtitle Update
     */
    $(document).on('click', '#ytpl_update_subtitle', function () {

        let Fields = $('.vpp--save');
        let Subtitle = {};
        let Config = {};

        Fields.each(function () {

            let Name = $(this).attr('name');

            if (Name.indexOf('subtitle_') !== -1) {
                Subtitle[Name] = $(this).val() !== '' ? JSON.parse($(this).val()) : {};
            }

        });

        Config['id'] = PageConfig.id;
        Config['subtitle'] = Subtitle;

        let ajaxData = {
            nonce: vpp_ajax_config.Nonce,
            action: 'ytpl_subtitle_update',
            config: JSON.stringify(Config)
        }

        $.ajax({
            type: "POST",
            url: vpp_ajax_config.AjaxUrl,
            data: ajaxData,
            success: function (resp) {

                Notification.Add({
                    Text: VPP_TRANSLATE.notification_subtitle_update_title,
                    AutoTime: true,
                    Ok: {Text: VPP_TRANSLATE.notification_ok}
                });

            },
            timeout: 10000
        });


    });

    /**
     * Create Popup
     */
    $(document).on('click', '#ytpl_show_popup_create', function () {

        VppPopup.open({
            id: 'ytpl_popup_setting',
            AjaxUrl: vpp_ajax_config.AjaxUrl,
            AjaxNonce: vpp_ajax_config.Nonce,
            AjaxAction: 'vpp_popup',
            AjaxData: 'create',
            title: VPP_TRANSLATE.popup_create_title,
            headerClose: (e, elm) => {
                elm.remove();
            },
            okButton: {
                text: 'Publish',
                callback: (e, elm) => {

                    let Inputs = elm.find('.vpp--save');
                    let Subtitle = {};
                    let Data = {};

                    Inputs.each(function () {

                        let Name = $(this).attr('name');

                        // Subtitle
                        if (Name.indexOf('subtitle_') !== -1) {

                            Subtitle[Name] = $(this).val() !== '' ? JSON.parse($(this).val()) : {};
                            return;

                        }

                        // Element
                        if (Name === 'elements') {

                            Data[Name] = $(this).val() !== '' ? JSON.parse($(this).val()) : {};
                            return;

                        }

                        // Quality or Tags
                        if (Name === 'quality' || Name === 'tags') {

                            Data[Name] = $(this).val() !== '' ? JSON.parse($(this).val()) : {};
                            return;

                        }

                        // Any
                        Data[Name] = $(this).val();

                    });

                    Data['subtitle'] = Subtitle;

                    let ajaxData = {
                        nonce: vpp_ajax_config.Nonce,
                        action: 'ytpl_save_video',
                        data: JSON.stringify(Data)
                    }

                    $.ajax({
                        type: "POST",
                        url: vpp_ajax_config.AjaxUrl,
                        data: ajaxData,
                        success: function (resp) {

                            if (page === 'video') {
                                ContentRender();
                            }
                            elm.remove();

                        },
                        timeout: 10000
                    });

                }
            }
        });

    });

    /**
     * Setting Popup
     */
    $(document).on('click', '#ytpl_show_popup_setting', function () {

        VppPopup.open({
            id: 'ytpl_popup_setting',
            AjaxUrl: vpp_ajax_config.AjaxUrl,
            AjaxNonce: vpp_ajax_config.Nonce,
            AjaxAction: 'vpp_popup',
            AjaxData: $(this).attr('data-popup'),
            title: VPP_TRANSLATE.popup_setting_title,
            cancelButton: {
                text: VPP_TRANSLATE.popup_setting_cancel,
                callback: (e, elm) => {
                    elm.remove();
                }
            },
            okButton: {
                text: VPP_TRANSLATE.popup_setting_save,
                callback: (e, elm) => {

                    let input = $(document).find('#ytpl_popup_setting .vpp--save');
                    let packed = {};

                    input.each(function () {
                        packed[$(this).attr('name')] = $(this).val();
                    });

                    let ajaxData = {
                        nonce: vpp_ajax_config.Nonce,
                        action: 'vpp_save_setting',
                        data: JSON.stringify(packed)
                    }

                    $.ajax({
                        type: "POST",
                        url: vpp_ajax_config.AjaxUrl,
                        data: ajaxData,
                        success: function (resp) {
                            elm.remove();
                        },
                        timeout: 10000
                    });

                }
            }
        });

    });

    /**
     * About Me Popup
     */
    $(document).on('click', '#ytpl_show_popup_about_me', function () {

        VppPopup.open({
            id: 'ytpl_popup_about_me',
            AjaxUrl: vpp_ajax_config.AjaxUrl,
            AjaxNonce: vpp_ajax_config.Nonce,
            AjaxAction: 'vpp_popup',
            AjaxData: $(this).attr('data-popup'),
            title: VPP_TRANSLATE.popup_about_title,
            headerClose: (e, elm) => {
                elm.remove();
            }
        });

    });

    /**
     * Edit video
     */
    $(document).on('click', '#ytpl_edit_video', function () {

        $(this).YTPL_Loading();

        page = 'video_edit';
        PageConfig = {
            id: $(this).attr('data-id')
        }
        ContentRender();

    });

    /**
     * Edit subtitle video
     */
    $(document).on('click', '#ytpl_video_subtitle', function () {

        page = 'subtitle_edit';
        PageConfig.id = $(this).attr('data-id');
        ContentRender();

    });

    /**
     * Delete Video
     */
    $(document).on('click', '#ytpl_video_delete', function () {

        let Id = $(this).attr('data-id');

        Notification.Add({
            Text: VPP_TRANSLATE.notification_delete_video_title,
            Ok: {
                Text: VPP_TRANSLATE.notification_ok,
                Callback: function () {

                    let ajaxData = {
                        nonce: vpp_ajax_config.Nonce,
                        action: 'ytpl_delete_video',
                        id: Id
                    }

                    $.ajax({
                        type: "POST",
                        url: vpp_ajax_config.AjaxUrl,
                        data: ajaxData,
                        success: function (resp) {

                            ContentRender();

                        },
                        timeout: 10000
                    });

                }
            },
            Cancel: {Text: VPP_TRANSLATE.notification_cancel}
        });

    });

    /**
     * Add playlist
     */
    $(document).on('click', '#ytpl_open_popup_playlist', function () {

        $('.ytpl-playlist-create').remove();

        let _this = $(this);
        let form = $('<div class="ytpl-playlist-create"></div>');
        let rtl = $('body').hasClass('rtl');

        form.append(
            '<label for="ytpl_playlist_name_form">Playlist Title:</label>\n' +
            '<input id="ytpl_playlist_name_form" type="text">\n' +
            '<div>\n' +
            '    <select>\n' +
            '        <option value="public">Public</option>\n' +
            '        <option value="private">Private</option>\n' +
            '    </select>\n' +
            '    <a class="ytpl-create">Create</a>\n' +
            '    <a class="ytpl-cancel">Cancel</a>\n' +
            '</div>'
        );

        form.css({
            'top': _this.offset().top + (_this.height() + 30),
            'left': !rtl ? _this.offset().left - 40 : 'auto',
            'right': rtl ? ($(window).width() - (_this.offset().left + _this.width())) - 40 : 'auto',
        });

        form.find('.ytpl-cancel').on('click', function () {
            form.remove();
        });

        form.find('.ytpl-create').on('click', function () {

            let name = form.find('input').val();
            let visibility = form.find('select').val();
            let ajaxData = {
                nonce: vpp_ajax_config.Nonce,
                action: 'ytpl_save_playlist',
                name: name,
                visibility: visibility
            }

            $.ajax({
                type: "POST",
                url: vpp_ajax_config.AjaxUrl,
                data: ajaxData,
                success: function (resp) {

                    form.remove();
                    if (page === 'playlist') {
                        ContentRender();
                    }

                },
                timeout: 10000
            });

        });

        $(document).bind("mousedown", function (e) {

            if (!$(e.target).parents(".ytpl-playlist-create")[0]) {
                form.remove();
            }

        });

        $('body').append(form);

    });

    /**
     * Edit Playlist
     */
    $(document).on('click', '.ytpl-playlist-list .ytpl-table-row button', function () {

        page = 'playlist_edit';
        PageConfig = {
            id: $(this).attr('data-id')
        }
        ContentRender();

    });

    /**
     * Auto save visibility playlist
     */
    $(document).on('click', '.ytpl-playlist-preview .ytpl-field-radio .ytpl-option', function () {

        let ajaxData = {
            nonce: vpp_ajax_config.Nonce,
            action: 'ytpl_update_playlist_visibility',
            id: PageConfig.id,
            visibility: $(this).attr('value')
        }

        $.ajax({
            type: "POST",
            url: vpp_ajax_config.AjaxUrl,
            data: ajaxData,
            success: function (resp) {
                // Empty
            },
            timeout: 10000
        });

    });

    /**
     * Delete playlist
     */
    $(document).on('click', '.ytpl-playlist-preview .ytpl-delete-button', function () {

        Notification.Add({
            Text: VPP_TRANSLATE.notification_delete_playlist_title,
            Ok: {
                Text: VPP_TRANSLATE.notification_ok,
                Callback: function () {

                    let ajaxData = {
                        nonce: vpp_ajax_config.Nonce,
                        action: 'ytpl_delete_playlist',
                        id: PageConfig.id
                    }

                    $.ajax({
                        type: "POST",
                        url: vpp_ajax_config.AjaxUrl,
                        data: ajaxData,
                        success: function (resp) {

                            page = 'playlist';
                            ContentRender();

                        },
                        timeout: 10000
                    });

                }
            },
            Cancel: {Text: VPP_TRANSLATE.notification_cancel}
        });

    });

    /**
     * Go to edit video page
     */
    $(document).on('click', '.ytpl-edit-playlist .ytpl-table-row button.ytpl-edit', function () {

        let _this = $(this);

        page = 'video_edit';
        PageConfig = {
            id: _this.attr('data-id')
        }
        ContentRender();

    });

    /**
     * Delete playlist video
     */
    $(document).on('click', '.ytpl-edit-playlist .ytpl-table-row button.ytpl-delete', function () {

        let _this = $(this);

        Notification.Add({
            Text: VPP_TRANSLATE.notification_delete_playlist_video_title,
            Ok: {
                Text: VPP_TRANSLATE.notification_ok,
                Callback: function () {

                    let ajaxData = {
                        nonce: vpp_ajax_config.Nonce,
                        action: 'ytpl_delete_playlist_video',
                        id: PageConfig.id,
                        video_id: _this.attr('data-id')
                    }

                    $.ajax({
                        type: "POST",
                        url: vpp_ajax_config.AjaxUrl,
                        data: ajaxData,
                        success: function (resp) {
                            ContentRender();
                        },
                        timeout: 10000
                    });

                }
            },
            Cancel: {Text: VPP_TRANSLATE.notification_cancel}
        });

    });

    /**
     * TODO ::: Comments
     * Reply
     */
    $(document).on('click', '.ytpl-comment-row button.ytpl-reply', function () {

        let CELL = $(this).parents('.ytpl-table-cell');
        let ReplySection = CELL.find('.ytpl-reply-section');

        ReplySection.show();

    });

    /**
     * Cancel Reply
     */
    $(document).on('click', '.ytpl-comment-row button.ytpl-cancel', function () {

        let CELL = $(this).parents('.ytpl-table-cell');
        let ReplySection = CELL.find('.ytpl-reply-section');

        ReplySection.hide();

    });

    /**
     * Send Reply
     */
    $(document).on('click', '.ytpl-comment-row button.ytpl-send', function () {

        let _this = $(this);
        let Section = _this.parents('.ytpl-reply-section');
        let Content = Section.find('.vpp--save');
        let ajaxData = {
            nonce: vpp_ajax_config.Nonce,
            action: 'ytpl_save_reply_comment',
            comment_id: _this.attr('data-id'),
            video_id: _this.attr('data-video'),
            content: Content.val()
        }

        $.ajax({
            type: "POST",
            url: vpp_ajax_config.AjaxUrl,
            data: ajaxData,
            success: function (resp) {
                ContentRender();
            },
            timeout: 10000
        });

    });

    /**
     * Go to video
     */
    $(document).on('click', '.ytpl-comment-row button.ytpl-to-video', function () {

        let _this = $(this);
        PageVideoEdit(_this.attr('data-id'));

    });

    /**
     * TODO ::: Search
     * Focus
     */
    $(document).on('focus', '.ytpl-search input', function () {

        let Search = $(this);
        let Main = Search.parents('.ytpl-search');

        Main.addClass('show-result');
        SearchResult(Main, Search.val());

    });

    /**
     * Search
     */
    $(document).on('keyup', '.ytpl-search input', function () {

        let Search = $(this);
        let Main = Search.parents('.ytpl-search');

        SearchResult(Main, Search.val());

    });

    /**
     * Go to page
     */
    $(document).on('mousedown', '.ytpl-search-result .ytpl-table-row', function () {

        PageVideoEdit($(this).attr('data-id'));

    });

    /**
     * Blur
     */
    $(document).on('blur', '.ytpl-search input', function () {

        let Search = $(this);
        let Main = Search.parents('.ytpl-search');

        Main.removeClass('show-result');

    });

    /**
     * TODO ::: Search Result
     */
    function SearchResult(Elm, Search) {

        let arg = {
            s: Search
        };

        let ajaxData = {
            nonce: vpp_ajax_config.Nonce,
            action: 'ytpl_search_video',
            config: JSON.stringify(arg)
        }

        $.ajax({
            type: "POST",
            url: vpp_ajax_config.AjaxUrl,
            data: ajaxData,
            success: function (resp) {
                Elm.find('.ytpl-search-result-content').html(resp);
            },
            timeout: 10000
        });

    }

    /**
     * TODO ::: Fn: Page Video Edit
     */
    function PageVideoEdit(video_id) {

        page = 'video_edit';
        PageConfig = {
            id: video_id
        }
        ContentRender();
        SwitchNave('video');

    }

    /**
     * TODO ::: Fn: Switch Nave Menu
     *
     * @param page
     */
    function SwitchNave(page) {

        let Nave = $('.ytpl-left-nav');
        let Selected = Nave.find('.ytpl-nav-item[data-page=' + page + ']')
        let Item = Nave.find('.ytpl-nav-item');

        if (Selected) {

            Item.removeClass('active');
            Selected.addClass('active');

        }

    }

    /**
     * TODO ::: Content Render
     */
    function ContentRender() {

        let ajaxData = {
            nonce: vpp_ajax_config.Nonce,
            action: 'vpp_page_' + page,
            config: JSON.stringify(PageConfig)
        }

        ajaxData['page'] = current_page;
        ajaxData['per_page'] = per_page;

        $.ajax({
            type: "POST",
            url: vpp_ajax_config.AjaxUrl,
            data: ajaxData,
            beforeSend: function () {
                $('.ytpl-page-content').YTPL_Loading();
            },
            complete: function () {
            },
            success: function (resp) {

                $('.ytpl-page-content').html(resp);

            },
            timeout: 10000
        });

    }

    /**
     * TODO ::: Table selector
     */
    function TableItemSelector(Table, Data, Lenght, Action) {

        let Body = Table.find('.ytpl-table-body');
        let Selector = $('<div class="ytpl-table-selector"></div>');
        let Old = Body.find('.ytpl-table-selector');
        let Animation = !Old[0];

        if (!Data[0]) {

            Old.addClass('animation');
            Old.removeClass('show');

            setTimeout(function () {
                Old.remove();
            }, 130);

            return false;

        } else {
            Old.remove();
        }

        Selector.append('<div class="ytpl-title">' + Data.length + ' Selected ' + (Data.length === Lenght ? '(Select All)' : '') + '</div>');
        Selector.append('<div><button>Delete</button></div>');
        Selector.attr('data', JSON.stringify(Data));
        Body.prepend(Selector);

        if (Animation) {

            Selector.addClass('animation');
            setTimeout(function () {
                Selector.addClass('show');
            }, 1);

        }

        Selector.find('button').on('click', function () {

            Notification.Add({
                Text: VPP_TRANSLATE.notification_delete_video_selector_title,
                Ok: {
                    Text: VPP_TRANSLATE.notification_ok,
                    Callback: function () {

                        let ajaxData = {
                            nonce: vpp_ajax_config.Nonce,
                            action: Action,
                            config: JSON.stringify(Data)
                        }

                        $.ajax({
                            type: "POST",
                            url: vpp_ajax_config.AjaxUrl,
                            data: ajaxData,
                            success: function (resp) {
                                ContentRender();
                            },
                            timeout: 10000
                        });

                    }
                },
                Cancel: {
                    Text: VPP_TRANSLATE.notification_cancel
                }
            });

        });

    }

});