<?php


class VPP_AUTO_VIDEO_CHANGE {

	/**
	 * VPP_AUTO_VIDEO_CHANGE constructor.
	 *
	 * @return bool|void
	 *
	 */
	public function __construct() {

		if ( is_admin() ) {
			return false;
		}

		$this->Init();

	}

	/**
	 * Init
	 */
	private function Init() {

		/** do_action vpp app auto video change init */
		do_action( 'vpp_app_auto_video_change_init' );

		$skinName = strtoupper( VPP::$setting->Player_Template() );
		$skin = 'VPP_SKIN_' . ( empty( $skinName ) ? 'YOUTUBE' : $skinName );

		$player = new $skin();
		$player->_enqueue_style();

		wp_enqueue_script( 'vpp_auto_video_change', VPP_PLUGIN_JS . 'vpp-auto-video-change.js' );
		$localize = [
			'AjaxUrl'      => admin_url( 'admin-ajax.php' ),
			'Nonce'        => wp_create_nonce( 'vpp' ),
			'HardChange'   => VPP::$setting->General_Hard_Auto_Video_Change(),
			'TemplateName' => VPP::$setting->Player_Template(),
		];
		wp_localize_script( 'vpp_auto_video_change', 'VPP_LOCALIZE', $localize );

	}

}

new VPP_AUTO_VIDEO_CHANGE();