<?php


class VPP_SKIN_MANAGEMENT {

	/** @var array $Skin skins */
	private $Skin = [];

	/**
	 * YTPL_SKIN_MANAGEMENT constructor.
	 */
	public function __construct() {

		/** do_action vpp app skin */
		do_action( 'vpp_app_skin' );

		if ( ! defined( 'VPP_PLUS' ) ) {
			include_once 'template/VPP_SKIN_YOUTUBE.php';
		}

		$this->Register();

	}

	/**
	 * Register
	 */
	private function Register() {

		if ( ! defined( 'VPP_PLUS' ) ) {
			$this->RegisterSkin( new VPP_SKIN_YOUTUBE() );
		}

		/** do_action vpp app skin register */
		do_action( 'vpp_app_skin_register', $this );

		add_filter( 'vpp-skin', array( $this, 'Set_Filter' ) );

	}

	/**
	 * Register Skin
	 *
	 * @param object $skin
	 *
	 */
	public function RegisterSkin( $skin ) {

		$this->Skin[ $skin->_get_slug() ] = $skin->_get_name();

	}

	/**
	 * Set Filter
	 *
	 * @param $attrs
	 *
	 * @return array
	 *
	 */
	public function Set_Filter( $attrs ) {

		return array_merge( $attrs, $this->Skin );

	}

}

new VPP_SKIN_MANAGEMENT();