<?php


class VPP_AJAX_AUTO_VIDEO_CHANGE {

	/**
	 * VPP_AJAX_AUTO_VIDEO_CHANGE constructor.
	 */
	public function __construct() {

		add_action( 'wp_ajax_vpp_auto_video_change', array( $this, 'Render' ) );
		add_action( 'wp_ajax_nopriv_vpp_auto_video_change', array( $this, 'Render' ) );

	}

	public function Render() {

		VPP_AJAX_NONCE::Nonce();

		$video_id = attachment_url_to_postid( sanitize_text_field( isset( $_REQUEST['src'] ) ? $_REQUEST['src'] : null ) );
		$skinName = strtoupper( VPP::$setting->Player_Template() );
		$skin = 'VPP_SKIN_' . ( empty( $skinName ) ? 'YOUTUBE' : $skinName );

		$youtube = new $skin( 'media', null, [
			'title'      => sanitize_text_field( isset( $_REQUEST['caption'] ) ? $_REQUEST['caption'] : '' ),
			'video_url'  => sanitize_text_field( isset( $_REQUEST['src'] ) ? $_REQUEST['src'] : null ),
			'video_meta' => wp_get_attachment_metadata( $video_id )
		] );

		$out = $youtube->_before_wrapper();
		$out .= $youtube->Player();
		$out .= $youtube->_after_wrapper();

		echo $out;

		die;

	}

}

new VPP_AJAX_AUTO_VIDEO_CHANGE();