<?php


class VPP_AJAX_POPUP_SETTING {

	/**
	 * VPP_AJAX_POPUP_SETTING constructor.
	 */
	public function __construct() {

		add_action( 'vpp_studio_popup_setting', array( $this, 'Render' ) );

	}

	/**
	 * Render
	 *
	 * @param $config
	 *
	 */
	public function Render( $config ) {

		?>

        <div class="ytpl-nav-box">
            <div class="ytpl-nav-items">
                <div class="ytpl-nav-item active" data-id="ytpl_setting_general">
					<?php echo __( 'General', VPP_TEXT_DOMAIN ); ?>
                </div>
                <div class="ytpl-nav-item" data-id="ytpl_setting_upload">
					<?php echo __( 'Upload Defaults', VPP_TEXT_DOMAIN ); ?>
                </div>
                <div class="ytpl-nav-item" data-id="ytpl_setting_player">
					<?php echo __( 'Player', VPP_TEXT_DOMAIN ); ?>
                </div>
            </div>
            <div class="ytpl-nav-content">

                <!-- General -->
                <div class="ytpl-nav-content-item" id="ytpl_setting_general" style="display: block">
					<?php

					VPP_FIELD::CheckBox(
						[
							'name'   => 'general-alert',
							'title'  => __( 'Show alert if video is missing, deleted or private', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->General_Alert(),
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'general-auto-video-change',
							'title'  => __( 'Auto videos change to VPP Skin', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->General_Auto_Video_Change(),
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'general-hard-auto-video-change',
							'title'  => __( 'Hard auto video change to VPP Skin', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->General_Hard_Auto_Video_Change(),
						]
					);

					/** do_action vpp studio popup setting general */
					do_action( 'vpp_studio_popup_setting_general' );

					?>
                </div>

                <!-- Upload -->
                <div class="ytpl-nav-content-item" id="ytpl_setting_upload" style="display: none">
					<?php

					VPP_FIELD::TextBox(
						[
							'name'  => 'default-upload-title',
							'title' => __( 'Title', VPP_TEXT_DOMAIN ),
							'value' => VPP::$setting->Default_Upload_Title()
						]
					);

					VPP_FIELD::Text_Area(
						[
							'name'  => 'default-upload-description',
							'title' => __( 'Description', VPP_TEXT_DOMAIN ),
							'value' => VPP::$setting->Default_Upload_Description()
						]
					);

					VPP_FIELD::Select(
						[
							'name'     => 'default-upload-visibility',
							'title'    => __( 'Visibility', VPP_TEXT_DOMAIN ),
							'selected' => VPP::$setting->Default_Upload_Visibility(),
							'options'  => [
								'public'  => __( 'Public', VPP_TEXT_DOMAIN ),
								'private' => __( 'Private', VPP_TEXT_DOMAIN ),
							]
						]
					);

					/** do_action vpp studio popup setting default */
					do_action( 'vpp_studio_popup_setting_default' );

					?>

                </div>

                <!-- Player -->
                <div class="ytpl-nav-content-item" id="ytpl_setting_player" style="display: none">
					<?php

					$template = apply_filters( 'vpp-skin', [] );
					VPP_FIELD::Select(
						[
							'name'     => 'player-template',
							'title'    => __( 'Skin', VPP_TEXT_DOMAIN ),
							'selected' => VPP::$setting->Player_Template(),
							'options'  => $template
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-setting',
							'title'  => __( 'Show Setting', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Setting(),
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-full-screen',
							'title'  => __( 'Show Full Screen', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Full_Screen(),
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-watermark',
							'title'  => __( 'Show Watermark', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Watermark(),
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-description',
							'title'  => __( 'Show Description', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Description(),
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-info',
							'title'  => __( 'Show Info', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Info(),
						]
					);

					/** do_action vpp studio popup setting player */
					do_action( 'vpp_studio_popup_setting_player' );

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-enable-right-click',
							'title'  => __( 'Enable right click', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Enable_Right_Click(),
						]
					);

					VPP_FIELD::GroupStart();

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-loop',
							'title'  => __( 'Loop', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Loop(),
						]
					);

					VPP_FIELD::CheckBox(
						[
							'name'   => 'default-player-video-info',
							'title'  => __( 'Video info', VPP_TEXT_DOMAIN ),
							'active' => VPP::$setting->Default_Player_Video_Info(),
						]
					);

					/** do_action vpp studio popup setting player right click */
					do_action( 'vpp_studio_popup_setting_player_right_click' );

					VPP_FIELD::GroupEnd();

					?>
                </div>

            </div>
        </div>

		<?php

	}

}

new VPP_AJAX_POPUP_SETTING();